require('./math_extension');
module.exports = (function () {
    /**
     * swap array[index_1] and array[index_2] value
     * @param {number} index_1 [0, array.length)
     * @param {number} index_2 [0, array.length)
     */
    Array.prototype.swap = function(index_1,index_2){
        let tmp = this[index_1];
        this[index_1] = this[index_2];
        this[index_2] = tmp;
    };
    Array.prototype.shuffle = function(){
        let half = Math.round(this.length / 2.0);
        for(let i=0;i<half;++i){
            this.swap(Math.random_int(this.length),Math.random_int(this.length));
        }
    };
    Array.prototype.last_index = function () {
        return this.length - 1;
    };
    Array.prototype.last = function () {
        if(this.length ===0) return null;
        else return this[this.last_index()];
    };
    Array.prototype.first = function () {
        if(this.length === 0) return null;
        else return this[0];
    };
    Array.prototype.clone = function () {
        return [...this];
    }

/*
    导致creator资源管理器面板文件夹打不开
    Array.prototype.toString = function () {
        let str='[';
        for (let obj of this) {
            str += obj.toString() + ' '
        }
        str += ']';
        return str;
    }
    */
})();