(function(){
    /**
     * draw poly line
     * @param {Array} points
     * @param {boolean} close
     */
    cc.Graphics.prototype.polyline = function(points, close=true){
        this.move_to_v2(points[0]);
        for(let i=1; i<points.length; ++i){
            this.line_to_v2(points[i]);
        }
        if(close) this.line_to_v2(points[0]);
    };
    /**
     *
     * @param {cc.Vec2} point
     */
    cc.Graphics.prototype.move_to_v2 = function (point) {
        this.moveTo(point.x, point.y);
    };
    /**
     *
     * @param {cc.Vec2} point
     */
    cc.Graphics.prototype.line_to_v2 = function (point) {
        this.lineTo(point.x, point.y);
    };
    /**
     *
     * @param {cc.Vec2} point
     * @param {number} size
     * @param {cc.Color} color
     */
    cc.Graphics.prototype.draw_cross = function (point, size=5, color=cc.Color.GREEN) {
        this.strokeColor = color;
        this.fillColor = cc.Color.TRANSPARENT;
        let half_size = size / 2;
        this.moveTo(point.x - half_size, point.y);
        this.lineTo(point.x + half_size, point.y);
        this.moveTo(point.x, point.y + half_size);
        this.lineTo(point.x, point.y - half_size);
    };

})();