(function () {
    //cc.log('import math_extension.js');
    /**
     * @description random a int value [num_1,num_2)
     * @param {number} num_1 - begin of random int range or max number of random value
     * @param {number} [num_2] - optional, end of random int range
     */
    Math.random_int = (num_1, num_2) => {
        if(num_2===undefined){
            num_2=num_1;
            num_1=0;
        }

        return Math.floor(Math.random() * (num_2-num_1)) + num_1;
    };
    /**
     * 1D array index to 2D array index
     * @param index
     * @param cols
     * @return {{row: number, col: number}}
     */
    Math.index_to_row_col = function (index, cols) {
        let row = Math.floor(index / cols);
        let col =  index % cols;
        return {row, col};
    };

    Math.row_col_to_index = function (row, col, cols) {
        return row * cols + col;
    };

    window.require_in_editor = function (module_name) {
        if(CC_EDITOR){
            return require(module_name);
        }
    };

    window.bind_private_method = function(symbol,obj){
        for (let func of obj[symbol]) {
            func.bind(obj);
        }
    }
})();