"use strict";
cc._RF.push(module, '8f911W+mpBLBJAK+FWydc7l', 'cc_graphyics_extension');
// scripts/utils/cc_graphyics_extension.js

"use strict";

(function () {
    /**
     * draw poly line
     * @param {Array} points
     * @param {boolean} close
     */
    cc.Graphics.prototype.polyline = function (points) {
        var close = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        this.move_to_v2(points[0]);
        for (var i = 1; i < points.length; ++i) {
            this.line_to_v2(points[i]);
        }
        if (close) this.line_to_v2(points[0]);
    };
    /**
     *
     * @param {cc.Vec2} point
     */
    cc.Graphics.prototype.move_to_v2 = function (point) {
        this.moveTo(point.x, point.y);
    };
    /**
     *
     * @param {cc.Vec2} point
     */
    cc.Graphics.prototype.line_to_v2 = function (point) {
        this.lineTo(point.x, point.y);
    };
    /**
     *
     * @param {cc.Vec2} point
     * @param {number} size
     * @param {cc.Color} color
     */
    cc.Graphics.prototype.draw_cross = function (point) {
        var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
        var color = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : cc.Color.GREEN;

        this.strokeColor = color;
        this.fillColor = cc.Color.TRANSPARENT;
        var half_size = size / 2;
        this.moveTo(point.x - half_size, point.y);
        this.lineTo(point.x + half_size, point.y);
        this.moveTo(point.x, point.y + half_size);
        this.lineTo(point.x, point.y - half_size);
    };
})();

cc._RF.pop();