"use strict";
cc._RF.push(module, 'd81a8YMTC1Iraofm+TVKn9E', 'math_extension');
// scripts/utils/math_extension.js

"use strict";

(function () {
    //cc.log('import math_extension.js');
    /**
     * @description random a int value [num_1,num_2)
     * @param {number} num_1 - begin of random int range or max number of random value
     * @param {number} [num_2] - optional, end of random int range
     */
    Math.random_int = function (num_1, num_2) {
        if (num_2 === undefined) {
            num_2 = num_1;
            num_1 = 0;
        }

        return Math.floor(Math.random() * (num_2 - num_1)) + num_1;
    };
    /**
     * 1D array index to 2D array index
     * @param index
     * @param cols
     * @return {{row: number, col: number}}
     */
    Math.index_to_row_col = function (index, cols) {
        var row = Math.floor(index / cols);
        var col = index % cols;
        return { row: row, col: col };
    };

    Math.row_col_to_index = function (row, col, cols) {
        return row * cols + col;
    };

    window.require_in_editor = function (module_name) {
        if (CC_EDITOR) {
            return require(module_name);
        }
    };

    window.bind_private_method = function (symbol, obj) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = obj[symbol][Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var func = _step.value;

                func.bind(obj);
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    };
})();

cc._RF.pop();