(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/scripts/utils/cc_node_extension.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'ff1b65v61pF9p+q6BuctLJV', 'cc_node_extension', __filename);
// scripts/utils/cc_node_extension.js

'use strict';

(function () {
    /**
     * get component of a node, if null add a new to it
     * @param {string|Type} type
     * @return {cc.Component}
     */
    cc.Node.prototype.get_or_add_component = function (type) {
        var comp = this.getComponent(type);
        if (comp === null) {
            comp = this.addComponent(type);
        }
        return comp;
    };
    /**
     * get child node by name, if not get add a new one.
     * @param {string} child_name
     * @return {cc.Node}
     */
    cc.Node.prototype.get_or_add_child = function (child_name) {
        // if(CC_EDITOR){
        //     cc.log('get_or_add_child, this:', this);
        // }

        var child = this.getChildByName(child_name);
        if (child === null) {
            child = new cc.Node(child_name);
            this.addChild(child);
        }
        return child;
    };
    /**
     *
     * @param {cc.Size} size
     */
    cc.Node.prototype.set_size = function (size) {
        this.width = size.w;
        this.height = size.h;
    };
    /**
     *
     * @param {cc.Vec2} anchor
     */
    cc.Node.prototype.set_anchor = function (anchor) {
        this.anchorX = anchor.x;
        this.anchorY = anchor.y;
    };
    /**
     *
     * @param {string} child_name
     * @param {string|type} type
     * @return {cc.Component}
     */
    cc.Node.prototype.get_or_add_component_in_child = function (child_name, type) {
        var child = this.get_or_add_child(child_name);
        var com = child.get_or_add_component(type);
        return com;
    };

    /**
     * get the node position in world space.
     * @return {cc.Vec2}
     */
    cc.Node.prototype.world_position = function () {
        return this.convertToWorldSpaceAR(cc.Vec2.ZERO);
    };

    var ACTIONS = 'actions';

    cc.Node.prototype.clear_actions = function () {
        this[ACTIONS] = [];
    };

    /**
     *
     * @param action
     */
    cc.Node.prototype.add_action = function (action) {
        this[ACTIONS].push(action);
    };

    /**
     *
     * @param {cc.Action[]|null} actions
     */
    cc.Node.prototype.run_actions = function (actions) {
        //cc.log('Node::run_actions() ');
        if (!actions) {
            actions = this[ACTIONS];
        }
        if (actions) {
            if (actions.length === 1) {
                this.runAction(actions[0]);
            } else if (actions.length > 1) {
                this.runAction(cc.sequence(actions));
            }
        }
    };
    /**
     * set parent by node or component, do not change world position.
     * @param {cc.Node|cc.Component} parent
     */
    cc.Node.prototype.set_parent = function (parent) {
        if (parent instanceof cc.Component) {
            parent = parent.node;
        }

        // let M = cc.mat4.create();
        // this.getWorldMatrix(M);
        // let position = cc.v3();
        // let rotation = cc.quat();
        // let scale = cc.v3();
        // M.getTranslation(position);
        // M.getScale(scale);
        // M.getRotation(rotation);

        var pos = this.world_position();
        //cc.log('Node::set_parent() wold position:',pos);
        this.parent = parent;
        var local_pos = parent.convertToNodeSpaceAR(pos);
        //cc.log('Node::set_parent() local position:',local_pos);
        this.setPosition(local_pos);
    };
})();

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=cc_node_extension.js.map
        